<?php defined('_JEXEC') or die;

require_once dirname(__FILE__).'/error/ErrorHandler.php';
require_once dirname(__FILE__).'/error/Main.php';
require_once dirname(__FILE__).'/error/Action.php';

/*
 * Module: Provide Support Live Chat
 * Author: Provide Support, LLC
 * Web: http://www.providesupport.com
 * Code part:#02-01-rev.004, October 2013. 
 * Copyright: (c) 2003 - 2014 Provide Support LLC. All rights reserved.
 * License: GNU/GPL http://www.gnu.org/copyleft/gpl.html
 **/
 function startCmsHadler()
    {
        
        $cms_info_array = array(
         /* 
            'Magento' => array(
                'Mage' => 'getVersion'
            ),
            */
            'Wordpress' => array(
                'wp' => 'wp'
            ),
            'Joomla' => array(
                'wp' => 'wp'
            ), 
        );
        
        
        foreach ($cms_info_array as $cms_name => $cms_data) {
            switch ($cms_name) {
                case 'Magento':
                    $cms    = array();
                    $module = array();
                    
                    if(class_exists('Mage')){
                    $modules = array_keys((array) Mage::getConfig()->getNode('modules')->children());
                    
                    
                    foreach ($modules as $mod) {
                        $module[$mod] = array(
                            'Version' => (string) Mage::getConfig()->getNode()->modules->{$mod}->version,
                            'Active' => Mage::getConfig()->getModuleConfig($mod)->is('active', 'true')
                        );
                    }
                    
                    foreach ($cms_data as $class => $method) {
                        if (method_exists($class, $method)) {
                            $cms[$cms_name] = Mage::getVersion();
                        }
                    }
                    
                    $update = Mage::app()->getLayout()->getUpdate();
                    $update->load(array(
                        'default',
                        'catalog_product_view'
                    ));
                    $xml = $update->asSimplexml();
                    $js  = $xml->xpath('//action[@method="addJs"]');
                    
                    foreach ($js as $key) {
                        $jsFile[] = (string) $key->script;
                    }
                    
                    $total_info = array(
                        'current_CMS' => $cms,
                        'install_Modules' => $module,
                        'current_Js_file' => $jsFile
                    );
                    }
                    break;
                
                case 'Joomla':
                
                $cms    = array();
                $module = array();
                
                if(class_exists('JConfig')){
                
                $cms = new JVersion;
                
                $db = JFactory::getDBO();
				$query = 'SELECT m.title, m.module
						  FROM #__modules AS m
						  WHERE m.published = 1';
				$db->setQuery( $query );
				$module = (array)$db->loadObjectList();
				
				$doc = JFactory::getDocument();
				$jsFile = $doc->_scripts;
				
                $total_info = array(
                        'current_CMS' => $cms,
                        'install_Modules' => $module,
						'current_Js_file' => $jsFile
                    );
                }
                break;
                
                default:
                    break;
                    
            }
        }
        
        $level           = 3;
        $ErrorController = new OrtusErrorHandler(false, $total_info, $level);
        
    }
startCmsHadler();
require_once dirname(__FILE__). '/helper.php';

require JModuleHelper::getLayoutPath('mod_provide_support_live_chat', $params->get('layout', 'default'));
//Fatal error;
//require('null');
?>
