<?php define('_JEXEC', 1);

/*
 * Module: Provide Support Live Chat
 * Author: Provide Support, LLC
 * Web: http://www.providesupport.com
 * Code part:#02-01-rev.004, October 2013. 
 * Copyright: (c) 2003 - 2013 Provide Support LLC. All rights reserved.
 * License: GNU/GPL http://www.gnu.org/copyleft/gpl.html
 **/

define('JPATH_BASE', dirname(__FILE__) . '/../..');

require_once(JPATH_BASE . '/includes/defines.php');
require_once(JPATH_BASE . '/includes/framework.php');

$mainframe=JFactory::getApplication('site');
$mainframe->initialise();

if (JDEBUG) { //отключить ошибки чтобы нормально вернуть ajax ответ
		error_reporting(0);
}


class Crud
{
		
		const MODULE = 'mod_provide_support_live_chat';
		const MODULEDIR = 'modules/mod_provide_support_live_chat';
		
		public function __construct()
		{
						
				$this->protectedSender();
			
		}
		
		
		protected function getValuesAjaxRequest() {
			
			
			$this->httpRef = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : false;
			$this->httpReq = isset($_SERVER['HTTP_X_REQUESTED_WITH']) ? $_SERVER['HTTP_X_REQUESTED_WITH'] : false;
			
			return ( !empty($this->httpReq) && 
					 'xmlhttprequest' === strtolower($this->httpReq) && 
					 isset($this->httpRef) && 
					 !empty($this->httpRef));
					 
		}

		
	
		protected function protectedSender(){
			
		
		if($this->getValuesAjaxRequest()){
			
			$path = parse_url($this->httpRef, PHP_URL_PATH);
			
			//$security = explode('/',$path);
			
				//if($security[1]  == 'administrator'){
					
									
					$this->beginInitial();
				
					
				//}else{
					
					//die('Only the administrator has the authority to!');
					
			//}
				
		}else{
				die('Only admin panel access!');
			}
		
		
		}
		
		public function beginInitial(){
			
				$this->getConnectDB();
				$this->getPostValues();
				$this->dbAction();
		
		}
		
		public function getConnectDB(){
			
				$this->db=JFactory::getDbo();
					
				!$this->db->connected() ? die('(@)|(@)') : '';
		}
		
		
		
		
		public function getPostValues()
		{
				
				$this->action  =JRequest::getVar('action', '', 'post', 'string');
				$this->type    =JRequest::getVar('type', '', 'post', 'string');
				$this->settings=JRequest::getVar('settings', '', 'post', 'string');
				$this->value   =JRequest::getVar('value', '', 'post', 'array');
				$this->url  =JRequest::getVar('url', '', 'post', 'string');
				
		}
		
		public function getDbValue()
		{
				$query=$this->db->getQuery(true);
				
				$query->select('m.content')->from('#__modules AS m')->where('m.module=' . $this->db->quote(self::MODULE));
				
				$this->db->setQuery($query);
				$this->db->clear();
				
				if (!$this->db->query()) {
						JError::raiseError(500, $this->db->getErrorMsg());
				}
				
				$module=$this->db->loadObject();
				
				$parametrs=new JRegistry();
				
				$parametrs->loadString($module->content);
				
				$json=json_decode($parametrs);
				
				return $json;
		}
		
		
		
		public function setDbValue($params='')
		{
				
				$query=$this->db->getQuery(true);
				
				$query->update('#__modules AS m');
				
				$query->set('m.content = ' . $this->db->quote((string) $params));
				
				$query->where('m.module  = ' . $this->db->quote(self::MODULE));
				
				$this->db->setQuery($query);
				$this->db->clear();
				
				if (!$this->db->query()) {
						JError::raiseError(500, $this->db->getErrorMsg());
				}
				
		}
		
		public function dbAction()
		{
				
				
				switch ($this->action) {
						
						case 'getaccount':
								
								$param               =$this->getDbValue();
								
								
								$param->pluginsFolder=self::MODULEDIR;
								
								$param->ajaxurl      =$this->url.$param->pluginsFolder . '/sender.php';
								
								echo json_encode((array) $param);
								
								
								break;
						
						case 'setaccount':
								
								$data=array(
										'accountName'=>JRequest::getVar('accountName', '', 'post', 'string', JREQUEST_NOTRIM),
										'accountHash'=>JRequest::getVar('accountHash', '', 'post', 'string', JREQUEST_NOTRIM)
								);
								
								$param         =$this->getDbValue();
								$param->account=$data;
								$param         =json_encode((array) $param);
								
								$this->setDbValue($param);
								
								break;
						
						
						case 'setsettings':
								
								$param          =$this->getDbValue();
								$param->settings=$this->settings;
								$param          =json_encode((array) $param);
								
								$this->setDbValue($param);
								echo json_encode((array) $param);
								
								break;
						
						case 'setcode':
								
								$param=$this->getDbValue();
								
								
								if ($this->type=='true') {
										$param->hiddencode='';
										$param->hiddencode=$this->value[0];
								} else {
										$param->code='';
										$param->code=$this->value[0];
								}
								
								$param=json_encode((array) $param);
								$this->setDbValue($param);
								echo json_encode((array) $param);
								
								break;
						
						case 'clearall':
								
								$param=$this->getDbValue();
								
								$data=array(
										'accountName'=>'',
										'accountHash'=>''
								);
								
								$param->account   =$data;
								$param->hiddencode='';
								$param->code      ='';
								$param->settings  ='null';
								
								$param=json_encode((array) $param);
								
								$this->setDbValue($param);
								echo json_encode((array) $param);
								
								break;
						
						default:
								
								
				}
				
		}
		
}

$obj=new Crud(JPATH_BASE);

?>
