<?php defined('_JEXEC') or die('(@)|(@)');

/*
 * Module: Provide Support Live Chat
 * Author: Provide Support, LLC
 * Web: http://www.providesupport.com
 * Code part:#02-01-rev.004, October 2013. 
 * Copyright: (c) 2003 - 2013 Provide Support LLC. All rights reserved.
 * License: GNU/GPL http://www.gnu.org/copyleft/gpl.html
 **/

jimport('joomla.form.formfield');
jimport('joomla.version');

class JFormFieldFieldname extends JFormField
{
	
	const MODULEDIR = 'modules/mod_provide_support_live_chat';

	//protected $type = 'fieldname';


	protected function getInput()
	{
		
	}
	
	
	public function initJsCss(){
		
		JHTML::script(self::MODULEDIR.'/js/script.js');
		JHTML::script(self::MODULEDIR.'/js/md5.js');
		JHTML::stylesheet(self::MODULEDIR.'/css/style.css');

	}
		
	protected function getAccess($groups=array(), $user_id=0){
			
			if ($user_id == 0) $user_id = JFactory::getUser()->id;
			if (count($groups) == 0 || $user_id == 0) return false;
			return (count(array_intersect(JFactory::getUser($user_id)->getAuthorisedGroups(), $groups))>0);
	}

	public function initVersion(){
		
	$version = new JVersion;
	$this->version = $version->getShortVersion();
	$this->compare2_5_0_3_0_0 = version_compare( $this->version, '2.5.0', 'ge' ) && version_compare( $this->version, '3.0.0', 'lt' );
	$this->compare3_0_0_3_0_3 =  version_compare( $this->version, '3.0.0', 'ge' ) && version_compare( $this->version, '3.0.3', 'lt' ) ;
	}

	public function getCurrentVersion(){
		
	  $this->groups = array(7,8); //access group Only ADMINISTRATOR and SUPER USERS
		
	  if($this->getAccess($this->groups)){
				
		$this->initVersion();
				
			if($this->compare2_5_0_3_0_0){
				
				JHTML::script(self::MODULEDIR.'/js/jquery.js');
				JHTML::script(self::MODULEDIR.'/js/jquery-noconflict.js');
				
				$this->getJsInit("				
				jQuery('.adminform').last().css('display', 'none');
				jQuery('#module-sliders').last().css('display', 'none');
				
				var conf = {
				'border': '1px solid #CCCCCC',
				'border-radius': '10px 10px 10px 10px',
				'padding': '10px 10px 20px',
				'width': 'auto'	
				};
				jQuery('#content-box').last().append(jQuery('#f7main'));
				jQuery('#f7main').css(conf)  
				
				");
				
				//$div =  'You have an older version to that module, please update your module. Joomla v. '.$this->version_joomla;
				$div = $this->getView();
				
				$this->initJsCss();
				
				return $div;
				
				
			}elseif($this->compare3_0_0_3_0_3){

					$this->getJsInit("
				
					jQuery('.nav-tabs > li:eq(2) > a').trigger('click');
					jQuery('.nav-tabs > li:eq(3) > a').css('display', 'none'); 
			");
			
			}else{
				
					$this->getJsInit("
			
					jQuery('.nav-tabs > li:eq(2) > a').css('display', 'none'); 
					jQuery('.nav-tabs > li:eq(1) > a').trigger('click'); 
	                jQuery('#moduleOptions .accordion-heading .accordion-toggle').trigger('click'); 
        		
			");
				
			}
			
				$this->initJsCss();
			
				$div = $this->getView();
				
				return $div;
		}else{
			
			$div = 'Only ADMINISTRATOR and SUPER USERS can use this module';
			
			return $div;
			
			}
	}
	
	
	
	
	
	protected function getJsInit($js = ''){
		
	$document=JFactory::getDocument();	
	$document->addScriptDeclaration("setTimeout(function () {".$js."}, 300);");
		
	}
	
	
	protected function connectdb($array = ''){
	
	$db = JFactory::getDbo();
	
	!$db->connected() ? die('Fatal error no connected to db!!!') : '';

	
	if(isset($array) && !empty($array)){
	
	$query = $db->getQuery(true);
		
	foreach($array as $action => $option){
	
		switch($action){
		
			case 'select':
			
				if(is_array($option)){
				
					$select_arr = array();
				
						foreach($option as $value){
						
							array_push($select_arr,$db->quoteName($value));
							
						}
			
				$query->select($select_arr);

				
				}else{
					$query->select($db->quoteName($option));
					}
					
			break;
			
			case 'from':
				
				$query->from($db->quoteName($option,'m'));
			
			break;
			
			case 'where':
				
				if(is_array($option)){
					
					$option_table = isset($option['table']) && !empty($option['table']) ? $option['table'] : '';
					$option_sing = isset($option['sing']) && !empty($option['sing']) ? $option['sing'] : '';
					$option_value = isset($option['value']) && !empty($option['value']) ? $option['value'] : '';
					
					
					$where_arr = $db->quoteName($option_table).$option_sing.$db->quote($option_value);
				
					$query->where($where_arr);	
				
				}else{
					$query->$where_arr($db->quoteName($option));
					}
			break;
					
			default:
			
			die('Fatal error!! No action - '.$action);
			break;	
				
	}

	}

	
	$db->setQuery($query);
	
	if (!$db->query()) {
		JError::raiseError(500, $this->db->getErrorMsg());
	}

	$value = $db->loadAssocList();


	return $value;
	
	}
	}
	
	public function subString($string ='', $maxlen = 60) {

		if(isset($string) && !empty($string)){
			
			$len = (mb_strlen($string) > $maxlen) ? 
					mb_strripos(mb_substr($string, 0, $maxlen), ' ') : 
					$maxlen;
					
			$cutStr = mb_substr($string, 0, $len);
		
		return (mb_strlen($string) > $maxlen) ? 
					   $cutStr . '...' : 
					   $cutStr;
}
}

	
	protected function getMenu(){
			
		
	
		$array = array(
						'select' => array(
									'm.id', 
									'm.parent_id',
									'm.title',
									'm.published',
									'm.menutype', 
									'm.level'),
						'from' => '#__menu',
						'where' => array(
									'table' => 'm.client_id',
									'sing' => '=',
									'value' => 0)
										
										);
						
		
		$value = $this->connectdb($array);
	
		if(count($value)>0 && is_array($value)){

		unset($value[0]); //delete Menu_Item_Root
		
		$div_menu = '<div id="selectPagesMenus" style="padding: 0 0 0 15px;">';
		
		$array = array(
						'select' => array(
											'm.id',
											'm.menutype',
											'm.title'
											),
						'from' => '#__menu_types',
						'where' => array(
									'table' => 'm.menutype',
									'sing' => ' <> ',
									'value' => '')
										
										);
						
		
			$menuTypes = $this->connectdb($array);

			if(count($menuTypes)>0 && is_array($menuTypes)){
			
			$tmp = array();
			
			foreach ($menuTypes as $type) {
				$tmp[$type['menutype']] = $type;
				$type['links'] = array();
			}
			
			foreach ($value as $link) {
				if (isset($tmp[$link['menutype']])) {
					
					$tmp[$link['menutype']]['links'][] = $link;

					unset($link['menutype']);
				}
			}

			foreach ($tmp as &$type) {
				if (count($type['links'])){
					
					$div_menu.= '<label class="menus-header">'.$this->subString($type['title']).'</label>';
							
					foreach ($type['links'] as $i => $link){
			
						if($link['published'] == -2){
				
							$published = '<span style="color:grey;">'.$this->subString($link['title']).' (in Trash) </span>';
							$disabled = 'disabled';
							$strike = $published;
					
						}elseif(!$link['published']){
					
							$published = ' ( not published )';	
							$disabled = '';
							$strike = '<strike>'.$this->subString($link['title']).$published.'</strike>' ;
									
						
						}else{
							
							$published = false;
							$disabled = '';
							$strike = $this->subString($link['title']);
						
						}
						$div_menu .= '<input type="checkbox" '.$disabled.' pageid="'.$link['id'].'">'.$strike.'<br />';
					}
				}
			} 
						$div_menu .= '</div>';
		
				return $div_menu;
				}
			}
	}
	

	protected function getPost(){
		
		
		$array = array(
						'select' => array(
									'm.id',
									'm.title',
									'm.state'
									),
									
						'from' => '#__content');
	
		$value = $this->connectdb($array);	
	
		if(count($value)>0 && is_array($value)){
			
		$div_post = '<div id="selectPostMenus" style="padding: 0 0 0 15px;">';
		
			foreach($value as $current_post){
			
				if($current_post['state'] == -2){
					
					$published = '<span style="color:grey;">'.$this->subString($current_post['title']).' (in Trash) </span>';
					$disabled = 'disabled';
					$strike = $published;
				
			}elseif(!$current_post['state']){
					
				$published = ' ( not published )';	
				$disabled = '';
				$strike = '<strike>'.$this->subString($current_post['title']).$published.'</strike>' ;
							
				
				}else{
					
				$published = false;
				$disabled = '';
				$strike = $this->subString($current_post['title']);
				
				}
					
				$div_post .= '<input type="checkbox" '.$disabled.' postid="'.$current_post['id'].'">'.$strike.'<br />';
						}
					$div_post .= '</div>';
		
				return $div_post;
			
			}
	}					
						


	protected function getLabel()
	{
		return $this->getCurrentVersion();
	}
	
	public function getView(){
		
		$div = '<div id="f7main">';
		$div .= '<div id="f7title">';
			$div .= 'Welcome to Provide Support Live Chat module settings page.<br/>Visit our website <a href="http://www.providesupport.com" target="_blank">www.providesupport.com</a> to find more information about our Live Chat system.';
		$div .= '</div>';
		$div .= '<div id="f7message">';
			$div .= '';
		$div .= '</div>';
		$div .= '<div id="f7accountInfo"></div>';
		$div .= '<div id="f7account">';
			$div .= '<div id="f7buttonE" class="f7buttonNoBorder">Existing Account</div>';
			$div .= '<div id="f7buttonN">New account</div>';
			$div .= '<div id="f7accountE">';
				$div .= '<div class="f7fields">';
					$div .= '<div class="f7label">';
						$div .= 'Your Provide Support account name:';
					$div .= '</div>';
					$div .= '<div class="f7field">';
						$div .= '<input type="text">';						
					$div .= '</div>';
				$div .= '</div>';
				$div .= '<div class="f7fields">';
					$div .= '<div class="f7label">';
						$div .= 'Your Provide Support account password:';
					$div .= '</div>';
					$div .= '<div class="f7field">';
						$div .= '<input type="password">';						
					$div .= '</div>';
				$div .= '</div>';
				$div .= '<div class="f7fields" style="display:none">';
					$div .= '<div class="f7label">';
						$div .= 'Your email:';
					$div .= '</div>';
					$div .= '<div class="f7field">';
						$div .= '<input type="email">';						
					$div .= '</div>';
				$div .= '</div>';
				$div .= '<div class="f7fields">';
					$div .= '<div class="f7field">';
						$div .= '<div id="f7accountSubmit">Connect to Account</div>';						
					$div .= '</div>';
				$div .= '</div>';
			$div .= '</div>';			
		$div .= '</div>';
			$div .= '<div id="f7settings" style="display:none">';
				$div .= '<div id="f7livePreview"></div>';
				$div .= '<div class="setting f7control">';
					$div .= '<input type="checkbox" id="f7pluginEnabled">Enable live chat module';
				$div .= '</div>';
				$div .= '<div class="f7separator"><div class="f7inner">Select chat button type</div></div>';
				$div .= '<div class="setting">';
					$div .= '<input type="radio" name="buttonAppearance" id="buttonImageType" class="f7button1">Graphics chat button';
					$div .= '<div class="settingInt">';
						$div .= '<input type="radio" name="customImages" id="buttonImageSource" class="f7button3">Use images selected in your account setings';
						$div .= '<div class="settingIntInt" style="width:240px;">';
							$div .= 'Images uploaded to Account Settings / Images page of your Provide Support account Control Panel will be used';
						$div .= '</div>';
					$div .= '</div>';
					$div .= '<div class="settingInt">';
						$div .= '<input type="radio" name="customImages" class="f7button4">Use custom images';
						$div .= '<div class="settingIntInt">';
							$div .= 'Online image URL <input type="text" id="buttonImageUrlOnline">';
						$div .= '</div>';
						$div .= '<div class="settingIntInt">';
							$div .= 'Offline image URL <input type="text" id="buttonImageUrlOffline">';
						$div .= '</div>';
						$div .= '<div class="settingIntInt" style="width:236px;margin:5px 0 5px 27px;font-size:10px;line-height:10px;">';
							$div .= 'You can specify here actual links to images stored on your server. If you use your  Live Chat account on several websites, this feature lets you display your custom chat icons, different from the ones uploaded to your Provide Support account ';
						$div .= '</div>';
					$div .= '</div>';
				$div .= '</div>';
				$div .= '<div class="setting">';
					$div .= '<input type="radio" class="f7button2" name="buttonAppearance">Text chat link';
					$div .= '<div class="settingInt">';
							$div .= 'Online Chat Link text <input type="text" id="buttonImageTextOnline">';
						$div .= '</div>';
						$div .= '<div class="settingInt">';
							$div .= 'Offline Chat Link text <input type="text" id="buttonImageTextOffline">';
						$div .= '</div>';
						$div .= '<div class="settingInt" style="width:236px;margin-left:39px;font-size:11px;line-height:10px;">';
							$div .= 'HTML formatting is supported for Chat Link texts';
						$div .= '</div>';
				$div .= '</div>';
				$div .= '<div class="f7separator"><div class="f7inner">Chat button position</div></div>';
				$div .= '<div class="setting">';
					$div .= '<input type="radio" location="define" name="buttonLocation">Show Chat Button in selected for a module position';
					$div .= '<div class="settingInt" style="width:300px;font-size:12px;line-height:13px;">';
						$div .= 'Your Live Chat button will be displayed according to the module position defined in  Details / Position '; 
						
						$div .=	 $this->compare2_5_0_3_0_0 ? 
						' modal ' : 
						'<a href="#details" onclick="jQuery(\'.nav-tabs > li:eq(0) > a\').trigger(\'click\');"> menu </a>';
					$div .= '</div>';
				$div .= '</div>';
				
				$div .= '<div class="setting">';
					$div .= '<input type="radio" location="fixed" name="buttonLocation">Show Сhat Button at a fixed position on the browser window';
					$div .= '<div class="settingInt" style=" padding-top: 0px; ">';
						$div .= '<div class="f7part1">';
							$div .= 'Vertical';
							$div .= '</div>';
						$div .= '<div class="f7part2">';
							$div .= '<input type="text" id="buttonLocationVerticalValue" value=50>';
							$div .= '</div>';
						$div .= '<div class="f7part3">';
							$div .= '<input type="radio" class="f7button5" name="specVerticalPx" id="buttonLocationVerticalBy">px';
								$div .= '<br />';
							$div .= '<input type="radio" class="f7button6" name="specVerticalPx" checked>%';
							$div .= '</div>';
						$div .= '<div class="f7part4">';
							$div .= '<input type="radio" class="f7button9" name="specVerticalFrom" id="buttonLocationVerticalFrom">from top';
								$div .= '<br />';
							$div .= '<input type="radio" class="f7button10" name="specVerticalFrom" checked>from bottom';
						$div .= '</div>';
					$div .= '</div>';
					$div .= '<div class="settingInt" style=" padding-top: 0px; ">';
						$div .= '<div class="f7part1">';
							$div .= 'Horizontal';
							$div .= '</div>';
						$div .= '<div class="f7part2">';
							$div .= '<input type="text" id="buttonLocationHorizontalValue" value=0>';
							$div .= '</div>';
						$div .= '<div class="f7part3">';
							$div .= '<input type="radio" class="f7button7" name="specHorizontalPx" id="buttonLocationHorizontalBy">px';
								$div .= '<br />';
							$div .= '<input type="radio" class="f7button8" name="specHorizontalPx" checked>%';
							$div .= '</div>';
						$div .= '<div class="f7part4">';
							$div .= '<input type="radio" class="f7button11" name="specHorizontalFrom" id="buttonLocationHorizontalFrom">from left';
								$div .= '<br />';
							$div .= '<input type="radio" class="f7button12" name="specHorizontalFrom" checked>from right';
						$div .= '</div>';
					$div .= '</div>';
					$div .= '<div class="settingInt" style="width:253px;margin-left:64px;">';
						$div .= 'Specify vertical and horizontal position in pixels or percent for your Chat Button';
					$div .= '</div>';
				$div .= '</div>';
				$div .= '<div class="f7separator"><div class="f7inner shortcodeSeparator">Display chat button at</div></div>';
		
				$div .= '<div class="setting selectPagesToggle">';
					$div .= '<input type="checkbox" id="buttonAvailableMenus">Menu Items';
					$div .= '<div class="settingInt">';
						$div .= '<input type="radio" class="f7button13" name="optionPages" id="buttonAvailableMenusWhich">All';
					$div .= '</div>';
					$div .= '<div class="settingInt">';
						$div .= '<input type="radio" class="f7button14" name="optionPages">Selected';
						
						$div .= $this->getMenu();
						
				$div .= '</div>';
				$div .= '</div>';
		
				$div .= '<div class="setting selectPostToggle">';
					$div .= '<input type="checkbox" id="buttonAvailablePost">Single Posts';
					$div .= '<div class="settingInt">';
						$div .= '<input type="radio" class="f7button15" name="optionPost" id="buttonAvailablePostWhich">All';
					$div .= '</div>';
					$div .= '<div class="settingInt">';
						$div .= '<input type="radio" class="f7button16" name="optionPost">Selected';
						
						$div .= $this->getPost();
						
				$div .= '</div>';
				$div .= '</div>';
				
				
				$div .= '<div class="setting">';
					$div .= '<input type="checkbox" id="buttonAvailableWhole">Monitor the whole website';
				$div .= '</div>';		
				
			$div .= '</div>';
		$div .= '<div id="f7wait" style="margin:4px auto;width:33px;"></div>';	
		$div .= '<div id="f7submit" style="cursor:pointer;display:none;">UPDATE</div>';		
	$div .= '</div>';
	
	return $div;
	}


} ?>
