<?php defined('_JEXEC')or die;

/*
 * Module: Provide Support Live Chat
 * Author: Provide Support, LLC
 * Web: http://www.providesupport.com
 * Code part:#02-01-rev.004, October 2013. 
 * Copyright: (c) 2003 - 2013 Provide Support LLC. All rights reserved.
 * License: GNU/GPL http://www.gnu.org/copyleft/gpl.html
 **/

class Code {
	
		const MODULEDIR = 'modules/mod_provide_support_live_chat';
		
		/**
		 * Singleton pattern
		 */
		var $_instance=NULL;
		
		/**
		 * Singleton pattern
		 */
		public function get_instance() {
				if (is_null(self::$_instance)) {
						self::$_instance=new Code();
				}
				
				return self::$_instance;
		}
		
		/**
		 * Constructor
		 */
		public function Code($module, $params) {
				
				jimport('joomla.application.module.helper');
				
				$this->module=$module;
				
				$this->getInitialModule();
				$this->getValuesModule();
				$this->getValuesMenuAndPost();
				$this->getCurrentVersion();
				
		}
		
		public function initVersion(){
		
			$version = new JVersion;
			$this->version_joomla = $version->RELEASE;

		}

		public function getCurrentVersion(){
		
			$this->initVersion();
			
			if($this->version_joomla[0] < 3){
				
				JHTML::script(self::MODULEDIR.'/js/jquery.js');
				JHTML::script(self::MODULEDIR.'/js/jquery-noconflict.js');
				
			}
		
		
		}
		
		
		protected function getInitialModule() {
				
				$this->document=JFactory::getDocument();
				$this->app     =JFactory::getApplication();
				
		}
		
		protected function getValuesModule() {
				
			if(isset($this->module->content)){
				$this->code =json_decode($this->module->content);
				@$this->value=json_decode((string) $this->code->settings);
			}
		}
		
		protected function getValuesMenuAndPost() {
				
				$this->current_menu      =@$this->app->getMenu()->getActive()->id;
				$this->current_post      =JRequest::getVar('id');
				$this->isset_current_menu=isset($this->current_menu)&&!empty($this->current_menu);
				
		}
		
		public function setJavaScript($message) {
				
				
				$javascript='if(window.addEventListener){ // Mozilla, Netscape, Firefox' . "\n";
				$javascript.='    window.addEventListener("load", function(){ ' . $message . ';}, false);' . "\n";
				$javascript.='} else { // IE' . "\n";
				$javascript.='    window.attachEvent("onload", function(){ ' . $message . ';});' . "\n";
				$javascript.='}';
				
				return $javascript;
		}
		
		public function setJsCode() {
			
 			    $this->code->code = isset($this->code->code) && !empty($this->code->code) ? $this->code->code: '';
				$this->code->hiddencode = isset($this->code->hiddencode) && !empty($this->code->hiddencode) ? $this->code->hiddencode: '';
				
				$this->jsCode="		var BUTTONTEXT = 'ProvideSupport : chat button code loaded';
				var HIDDENTEXT = 'ProvideSupport : hidden monitoring code loaded';

				var f7php = new Object();
				var f7s = new Object();	
	
				f7s = JSON.parse(" . json_encode((string) $this->code->settings) . ");//f7php.settings
				f7php.code = " . json_encode((string) $this->code->code) . ";
				f7php.hiddencode = " . json_encode((string) $this->code->hiddencode) . ";
	
				showChat = function(code){
				var codeBlock = document.createElement('div');
				codeBlock.className = 'f7x';
				document.body.appendChild(codeBlock);
				
				jQuery('.f7x').html(code);	
			
				/*
				conf = {'position': 'fixed','width': 'auto','height': 'auto','z-index': 10000}
				jQuery('.f7x').css(conf);
				*/
				
				jQuery('.f7x').css(f7s.buttonLocationHorizontalFrom,f7s.buttonLocationHorizontalValue + f7s.buttonLocationHorizontalBy);
				jQuery('.f7x').css(f7s.buttonLocationVerticalFrom,f7s.buttonLocationVerticalValue + f7s.buttonLocationVerticalBy);
			
				//console.log(f7s);
			}; ";
			
		}
		
		public function setCode() {
				
				if ($this->value->buttonLocation=='define') {
						
						echo '<div id= "f7x">' . $this->code->code . '</div>';
						
				} else {
						
						$this->document->addScriptDeclaration($this->setJavaScript($this->jsCode . 'showChat(f7php.code); console.log(BUTTONTEXT);'));
						
				}
				
		}
		
		public function setHiddenCode() {
				
				if ($this->value->buttonLocation=='define') {
						
						echo '<div id= "f7x">' . $this->code->hiddencode . '</div>';
						
				} else {
						
						$this->document->addScriptDeclaration($this->setJavaScript($this->jsCode . 'showChat(f7php.hiddencode); console.log(HIDDENTEXT);'));
						
				}
				
				
				
		}
		
	public function buttonAvailableWhich() {
				
				
				
				if ($this->value->buttonAvailableMenusWhich=='all'&&$this->value->buttonAvailablePostWhich=='all') {
						
						$this->setCode();
						
				}
				
				if ($this->value->buttonAvailableMenusWhich=='all'&&$this->value->buttonAvailablePostWhich=='selected') {
						
						$this->buttonAvailableOneWhich('menus', 'post');
						
				} elseif ($this->value->buttonAvailablePostWhich=='all'&&$this->value->buttonAvailableMenusWhich=='selected') {
						
						$this->buttonAvailableOneWhich('post', 'menus');
						
						
				} elseif ($this->value->buttonAvailableMenusWhich=='selected'&&$this->value->buttonAvailablePostWhich=='selected') {
						
						$this->buttonAvailableOneWhich('selected');
						
				}
		}
		
		public function startCode() {
			
			if(isset($this->value->pluginEnabled)){
				
				if ($this->value->pluginEnabled) {
						
						$this->setJsCode();
						
						if ($this->value->buttonAvailableWhole&&(!$this->value->buttonAvailableMenus&&!$this->value->buttonAvailablePost)) {
								
								$this->setHiddenCode();
								
								
						} elseif ($this->value->buttonAvailableMenus&&$this->value->buttonAvailablePost) {
								
								$this->buttonAvailableWhich();
								
						} elseif ($this->value->buttonAvailableMenus==true&&$this->value->buttonAvailablePost==false) {
								
								
								$this->buttonAvailableOneWhich('menus', 'menus');
								
						} elseif ($this->value->buttonAvailableMenus==false&&$this->value->buttonAvailablePost==true) {
								
								$this->buttonAvailableOneWhich('post', 'post');
						}
				}
			}
		}
		
		public function buttonAvailableOneWhich($option='', $var='') {
				
				switch ($option) {
						
						case 'menus':
								
								if ($this->value->buttonAvailableMenusWhich=='all'&&$this->isset_current_menu) {
										
										$this->setCode();
										
								} else {
										
										$this->getCode($var);
										
								}
								
								break;
						
						case 'post':
								
								if ($var == 'menus'){
									
									if ($this->value->buttonAvailablePostWhich=='all'&&!$this->isset_current_menu) {
										
										$this->setCode();
										
										} else {
												
												$this->getCode($var);
										}
									
									} else {
									
								if($this->value->buttonAvailableWhole){
								
									if (($this->value->buttonAvailablePostWhich=='all' || $this->value->buttonAvailablePostWhich=='selected')&&$this->isset_current_menu) {
											
											$this-> setHiddenCode();
									
									} elseif ($this->value->buttonAvailablePostWhich=='all'&& !$this->isset_current_menu) {
											
											$this->setCode();
									
									} elseif ($this->value->buttonAvailablePostWhich=='selected' && !$this->isset_current_menu) {
										
											$this->getCode($var);
									}
							
								} elseif ($this->value->buttonAvailablePostWhich=='all'&& !$this->isset_current_menu) {
										
												$this->setCode();
											
									} elseif ($this->value->buttonAvailablePostWhich=='selected'&& !$this->isset_current_menu) {
											
												$this->getCode($var);
									}		
								
							}
								
								break;
						
						
						case 'selected':
								
								
								if (!empty($this->current_menu)) {
										
										$var='menus';
										$this->getCode($var);
										
										
								} else {
										
										$var='post';
										$this->getCode($var);
								}
								
								break;
						
						default:
								die('Fatal error!! No option in buttonAvailableOneWhich = ' . $option);
								break;
								
				}
				
		}
		
		public function getCode($var='') {
				
				if ($this->getList($var)) {
						
						$this->setCode();
						
				} else {
						
						if ($this->value->buttonAvailableWhole) {
								
								$this->setHiddenCode();
								
						}
				}
				
				
		}
		
		public function getList($list='') {
				
				$search_id=0;
				
				switch ($list) {
						
						case 'menus':
								$current_id=$this->current_menu;
								$array_list=$this->value->buttonAvailableMenusList;
								break;
						
						case 'post':
								$current_id=$this->current_post;
								$array_list=$this->value->buttonAvailablePostList;
								break;
						
						default:
								$array_list=array();
								die('Fatal error!! No value in array_list (func getList())');
								break;
								
				}
				
				foreach ($array_list as $val) {
						
						if ((int) $current_id==(int) $val) {
								$search_id=(int) $val;
						}
						
				}
				
				return $search_id;
		}
		
		
}
?>
